/*
Just a helper function from https://www.w3schools.com/ used to set a cookie.
You will most likely use some other library for this
*/
function getCookie(cname) {
var name = cname + "=";
var decodedCookie = decodeURIComponent(document.cookie);
var ca = decodedCookie.split(';');
for(var i = 0; i <ca.length; i++) {
var c = ca[i];
while (c.charAt(0) === ' ') {
c = c.substring(1);
}
if (c.indexOf(name) === 0) {
return c.substring(name.length, c.length);
}
}
return "";
}
/*
Example of clean up function that will remove cookies set which does not follow the given user consent
*/
function cookiePolicyConsentSyncforApp(cookiePolicy){
if(cookiePolicy.cookiesRequireConsent && !cookiePolicy.allowFunctionalCookies){
// Delete cookie already set, because the end user did not give consent.
var cookieExpireDate = new Date();
cookieExpireDate.setDate(cookieExpireDate.getDate() - 1);
document.cookie = getAppScriptCookieName() +"=;expires=" + cookieExpireDate.toUTCString();
}
}
/*
Example of a simple custom scripts that sets a cookie categorized as a functional cookie.
Notice the cookie is only set if the user have accepted this type of cookies.
*/
function setAppScriptSetFunctionalCookie(cookieValue){
if(!CookiePolicy.cookiesRequireConsent || CookiePolicy.allowFunctionalCookies){
/*
Only set the cookie if the end user gave consent.Or if the shop is not setup to enforce cookie consent (CookiePolicy.cookiesRequireConsent).
The CookiePolicy object is a global scope variable emitted to the shop markup by the shop system.
*/
var cookieExpireDate = new Date();
cookieExpireDate.setDate(cookieExpireDate.getDate() + 666);
document.cookie = getAppScriptCookieName() +"="+cookieValue+";expires=" + cookieExpireDate.toUTCString();
}
}
/*
Adding some element to the UI of the shop storefront, which allows the end user to input a value that can be stored in cookie.
Notice that the UI behaves differently based on the cookie consent given by the end user.
Execute this function on document ready to run the demo.
*/
function appScriptAppendNameInputToUI(){
var container = $('#webshop-basket');
var uiElement = $('<div id="cookie-consent-demo-container"></div>');
$(uiElement).append('<h3>Demo injected from app</h3>');
if(!CookiePolicy.cookiesRequireConsent || CookiePolicy.allowFunctionalCookies){
var nameFromCookie = getCookie(getAppScriptCookieName());
if(nameFromCookie.length > 0){
$(uiElement).append('<div>Hi <b>'+nameFromCookie+'</b> welcome</div>');
}
else{
$(uiElement).append('<div>Please enter your name</div>');
$(uiElement).append('<input type="text" id="app-script-user-name-input"/>');
$(uiElement).append('<input type="button" value="OK" onclick="saveNameInCookie()">');
}
}
else{

$(uiElement).append('<div>Sorry you have disabled functional cookies.</div>');
$(uiElement).append('<div>Please change your cookie consent to enable this feature</div>');
}
container.append(uiElement);
}
/*
Stores value from user input in cookie
*/
function saveNameInCookie(){
var nameInput = $('#app-script-user-name-input').val();
setAppScriptSetFunctionalCookie(nameInput);
document.location.reload(true);
}
/*
Helper function to get name of the cookie used by this demo script
*/
function getAppScriptCookieName(){
return 'app-script-name-functional-cookie';
}
/*
Sync app cookies with consent
*/
$(document).ready(function(){cookiePolicyConsentSyncforApp(CookiePolicy)})